/****************************************************************************
 * @file: Sensor feedback file
 * @author: Young Leon
 * @version: V1.0
 * @data: 2022/10/18
 * @brief: Hall sensor feedback file
 * @note:
 * @Copyright (C) 2022 Novosense All rights reserved.
 */

#ifndef __FBK_H__
#define __FBK_H__
/*********************************** INCLUDE ***********************************/

#include "main.h"

#define STARTUP_TABLE_LEN 16
/*********************************** INTERFACE **********************************/
extern uint8_t g_FBKRotorPosition;
extern uint16_t g_FBKRotorSpeed;
extern uint8_t g_FBKRotorSpeedOV;
extern uint16_t g_FBKStartupTable[STARTUP_TABLE_LEN];
extern uint16_t g_FBKStartupDutyTable[STARTUP_TABLE_LEN];
extern uint16_t g_FBKStartupSteps;

/*********************************** PUBLICK FUNCTION ****************************/

void FBK_Init(void);
void FBK_Init(void);
void FBK_ReadRotorSpeed(void);
void FBK_DisableInterrupts(void);
void FBK_EnableInterrupts(void);
uint8_t FBK_ReadRotorPosition(void);
void FBK_InitStartupTable(void);
void FBK_DisableBEMFCCommutation(void);
void FBK_EnableBEMFCCommutation(void);

/*********************************** DEFINITION ***********************************/

#endif //__FBK_H__
