/****************************************************************************
 * @file    : main.c
 * @author  : Novosense
 * @version : V1.0
 * @data:    2022/10/18
 * @brief   : A special header file containing some basic header files
 * @note
 * Copyright (C) 2021 Novosense All rights reserved.
 ****************************************************************************/
/************************************************************
 ************************************************************
 * @par Edition History
 * -V1.0  2022.10.18
 *        -first version for NSUC16x0 sensorless BLDC Motor with
 *          six step commutation.
 *
 ************************************************************/

#include "main.h"

uint8_t g_readPositon = 0;
int main()
{
    PrintfInit(115200);
    FBK_Init();
    MOT_Init();
    FBK_InitStartupTable();
    
    GPIO->MXR_b.PM0 = 0;
    GPIO->DTR_b.DT  = 7;
    GPIO->DER_b.DE0 = 1;

    GPIO->MXR_b.PM1 = 1;

    MCM_SetMotorOff();
    delay_ms(1000);
    g_MCMPwmWidth = 0;
    MCM_StartCWRotate();

    int cnt = 0;
    while (1) {
        if (!GPIO->PDI_b.DI0) {
            if (cnt == 0) {
                MCM_ControlBrake();
                cnt = 1;
            } else {
                MCM_StartCCWRotate();
                cnt = 0;
            }
            delay_ms(500);
        }
    }


    return 0;
}
